/*
 * Copyright (C) 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.clearsilver.jsilver.output;

/**
 * Simple Provider interface for the output buffer.
 */
public interface OutputBufferProvider {

  /**
   * Returns a clean Appendable buffer ready to use while rendering.
   */
  Appendable get();

  /**
   * Tells the provider that this buffer is free to be reused.
   * 
   * @param buffer the Appendable object handed out by {@link #get}
   */
  void release(Appendable buffer);
}
